# Automatic Discrimination between Cognates and Borrowings for Romance Languages

This repository contains the codebase used for machine learning experiments for automatic cognate detection based on the proposed database.
The code is written in Python and organized in Jupyter Notebooks. 
To run the code, you will need to install dependencies found in the `requirements.txt` file and start a Jupyter Notebook engine.

Repository contents include:

- Code for training and evaluating ensemble-based models: under `code/ensemble.ipynb`
- Code for training and evaluating Transformer-based models: under `code/transformer.ipynb`
- Additionally, a script for generating negative examples as described in the paper: under `code/generate_negative.py`

The repository also contains data used in the reported experiments, as train and test splits (as they were used and as they are expected in the code).
Can be found under `train_test`.


